﻿Imports System.Runtime.InteropServices

Public Class ClassForDS820_x64
    Implements IDisposable

    Sub Dispose() Implements IDisposable.Dispose
    End Sub

    Declare Function CvInitialize Lib "DS820Stat64.dll" (<MarshalAs(UnmanagedType.LPWStr)> ByVal pszPortName As String) As Integer
    Declare Function CvGetVersion Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
    Declare Function CvGetSensorInfo Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
    Declare Function CvGetMedia Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
    Declare Function CvGetStatus Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function CvGetPQTY Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function CvGetCounterL Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function CvGetCounterA Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function CvGetCounterB Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function CvGetMediaCounter Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function CvGetMediaColorOffset Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function CvGetMediaLotNo Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
    Declare Function CvSetColorDataVersion_ Lib "DS820Stat64.dll" Alias "CvSetColorDataVersion" (ByVal lPortNum As Integer, ByVal lpBuff As Integer, ByVal bLen As Integer) As Integer
    Declare Function CvSetColorDataWrite_ Lib "DS820Stat64.dll" Alias "CvSetColorDataWrite" (ByVal lPortNum As Integer, ByVal lpBuff As Integer, ByVal bLen As Integer) As Integer
    Declare Function CvGetColorDataVersion Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
    Declare Function CvSetColorDataClear Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function CvGetColorDataChecksum Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
    Declare Function CvGetSerialNo Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
    Declare Function CvGetResolutionH Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function CvGetResolutionV Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function CvGetFreeBuffer Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function CvSetClearCounterA Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function CvSetClearCounterB Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function CvSetFirmwUpdateMode Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function CvSetFirmwDataWrite_ Lib "DS820Stat64.dll" Alias "CvSetFirmwDataWrite" (ByVal lPortNum As Integer, ByVal lpBuff As Integer, ByVal bLen As Integer) As Integer
    Declare Function CvSetCommand_ Lib "DS820Stat64.dll" Alias "CvSetCommand" (ByVal lPortNum As Integer, ByVal lpCmd As Integer, ByVal dwCmdLen As Integer) As Integer
    Declare Function CvGetCommand_ Lib "DS820Stat64.dll" Alias "CvGetCommand" (ByVal lPortNum As Integer, ByVal lpCmd As Integer, ByVal dwCmdLen As Integer, ByVal lpRetBuff As String, ByVal dwRetBuffSize As Integer, ByRef lpdwRetLen As Integer) As Integer
    Declare Function CvGetCommandEX_ Lib "DS820Stat64.dll" Alias "CvGetCommandEX" (ByVal lPortNum As Integer, ByVal lpCmd As Integer, ByVal dwCmdLen As Integer, ByVal lpRetBuff As String, ByVal dwRetBuffSize As Integer) As Integer
    Declare Function CvGetCommandEX_ Lib "DS820Stat64.dll" Alias "CvGetCommandEX" (ByVal lPortNum As Integer, ByVal lpCmd As Integer, ByVal dwCmdLen As Integer, ByVal lpRetBuff() As Byte, ByVal dwRetBuffSize As Integer) As Integer
    '
    Declare Function PortInitialize Lib "DS820Stat64.dll" (<MarshalAs(UnmanagedType.LPWStr)> ByVal pszPortName As String) As Integer
    Declare Function PortInitializeEX Lib "DS820Stat64.dll" (<MarshalAs(UnmanagedType.LPWStr)> ByVal pszPortName As String, <MarshalAs(UnmanagedType.LPWStr)> ByVal pszPrinterName As String) As Integer
    Declare Function RegisterPrinterName Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, <MarshalAs(UnmanagedType.LPWStr)> ByVal pszPrinterName As String) As Integer
    Declare Function GetFirmwVersion Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
    Declare Function GetSensorInfo Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
    Declare Function GetMedia Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
    Declare Function GetStatus Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function GetPQTY Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function GetCounterL Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function GetCounterA Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function GetCounterB Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function GetCounterP Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function GetCounterMatte Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function GetCounterM Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function GetMediaCounter Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function GetMediaCounterH Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function GetMediaColorOffset Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function GetMediaLotNo Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
    Declare Function GetRfidMediaClass Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
    Declare Function GetRfidReserveData Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String, ByVal dwPAge As Integer) As Integer
    Declare Function SetColorDataVersion_ Lib "DS820Stat64.dll" Alias "SetColorDataVersion" (ByVal lPortNum As Integer, ByVal lpBuff As Integer, ByVal bLen As Integer) As Integer
    Declare Function SetColorDataWrite_ Lib "DS820Stat64.dll" Alias "SetColorDataWrite" (ByVal lPortNum As Integer, ByVal lpBuff As Integer, ByVal bLen As Integer) As Integer
    Declare Function GetColorDataVersion Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
    Declare Function GetColorDataVersionRes Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String, ByVal dpi As Integer) As Integer
    Declare Function SetColorDataClear Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function GetColorDataChecksum Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
    Declare Function GetColorDataChecksumRes Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String, ByVal dpi As Integer) As Integer
    Declare Function GetSerialNo Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String) As Integer
    Declare Function GetResolutionH Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function GetResolutionV Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function GetFreeBuffer Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function SetClearCounterA Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function SetClearCounterB Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function SetClearCounterM Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function SetCounterP Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal Counter As Integer) As Integer
    Declare Function SetFirmwUpdateMode Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function SetFirmwDataWrite_ Lib "DS820Stat64.dll" Alias "SetFirmwDataWrite" (ByVal lPortNum As Integer, ByVal lpBuff As Integer, ByVal bLen As Integer) As Integer
    Declare Function SetCutterMode Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal d As Integer) As Integer
    Declare Function SetRettentionMode Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal d As Integer) As Integer
    Declare Function GetInitialMediaCount Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function SetUSBSerialEnable Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal b As Boolean) As Integer
    Declare Function GetUSBSerialEnable Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer

    Declare Function SetFullCutterSetup Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal lSize1 As Integer, ByVal lSize2 As Integer, ByVal lSize3 As Integer, ByVal lSize4 As Integer, ByVal lSize5 As Integer, ByVal lSize6 As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean
    Declare Function SetStandbyTime Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal lTime As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean
    Declare Function GetStandbyTime Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function SetEndKeepMode Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal lMode As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean
    Declare Function GetEndKeepMode Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function SetFullCutterSetupEX Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal lCutSize1 As Integer, ByVal lCutSize2 As Integer, ByVal lCutSize3 As Integer, ByVal lCutSize4 As Integer, ByVal lCutSize5 As Integer, ByVal lCutSize6 As Integer, ByVal DustSize As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean
    Declare Function GetPanoramaPrintable Lib "DS820Stat64.dll" (ByVal lPortNum As Integer) As Integer
    Declare Function SetOvercoatFinish Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal ovcoat As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean
    Declare Function GetColorDataVersionResEX Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String, ByVal dpi As Integer, ByVal lMedia As Integer) As Integer
    Declare Function GetColorDataChecksumResEX Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal s As String, ByVal dpi As Integer, ByVal lMedia As Integer) As Integer
    Declare Function SetPrintSpeed Lib "DS820Stat64.dll" (ByVal lPortNum As Integer, ByVal lPrintSpeed As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean

End Class


