﻿Imports System.Runtime.InteropServices

Public Class ClassPanoramaModule_x64
    Inherits ClassPanoramaCommon

    Implements IDisposable

    Sub Dispose() Implements IDisposable.Dispose
    End Sub

    '*! ---------------------------------------
    '*	Declare functions.
    '*  ---------------------------------------

    Declare Function PP_Reset Lib "PanoramaProc64.dll" () As Integer

    Declare Function PP_Divide Lib "PanoramaProc64.dll" ( _
     <[In](), Out()> ByVal imgDst0() As Byte, _
     <[In](), Out()> ByVal imgDst1() As Byte, _
     <[In](), Out()> ByVal imgDst2() As Byte, _
     <[In](), Out()> ByVal imgSrc() As Byte, _
     ByRef param As StructDivideParam _
     ) As Integer

    Declare Function PP_ProcessLhs Lib "PanoramaProc64.dll" ( _
     <[In](), Out()> ByVal imgData() As Byte, _
     <MarshalAs(UnmanagedType.LPWStr)> ByVal iccTblFilename As String, _
     <MarshalAs(UnmanagedType.LPWStr)> ByVal lutFilename As String, _
     ByVal overlapWidth As UInt32, _
     ByVal srcWidth As UInt32, _
     ByVal srcHeight As UInt32 _
     ) As Integer

    Declare Function PP_ProcessRhs Lib "PanoramaProc64.dll" ( _
     <[In](), Out()> ByVal imgData() As Byte, _
     <MarshalAs(UnmanagedType.LPWStr)> ByVal iccTblFilename As String, _
     <MarshalAs(UnmanagedType.LPWStr)> ByVal lutFilename As String, _
     ByVal overlapWidth As UInt32, _
     ByVal srcWidth As UInt32, _
     ByVal srcHeight As UInt32 _
       ) As Integer

    Declare Function PP_ProcessBoth Lib "PanoramaProc64.dll" ( _
     <[In](), Out()> ByVal imgData() As Byte, _
     <MarshalAs(UnmanagedType.LPWStr)> ByVal iccTblFilename As String, _
     <MarshalAs(UnmanagedType.LPWStr)> ByVal lutFilename As String, _
     ByVal overlapWidth As UInt32, _
     ByVal srcWidth As UInt32, _
     ByVal srcHeight As UInt32 _
     ) As Integer

    Declare Function PP_SetCorrectionParam Lib "PanoramaProc64.dll" ( _
    ByVal temp As Double, _
    ByVal humid As Double, _
    <MarshalAs(UnmanagedType.LPWStr)> ByVal lutFilename As String _
    ) As Integer

    Declare Sub PP_Initialize Lib "PanoramaProc64.dll" ()
    Declare Sub PP_Finalize Lib "PanoramaProc64.dll" ()

    Declare Function PP_DutyYMC Lib "PanoramaProc64.dll" ( _
    <[In](), Out()> ByVal imgData() As Byte, _
          ByRef param As StructDutyImageParam _
          ) As Integer

    Declare Function PP_GetDutyFromLUT Lib "PanoramaProc64.dll" ( _
    ByRef param As StructDutyOfLUTFile, _
      <MarshalAs(UnmanagedType.LPWStr)> ByVal lutFilename As String _
      ) As Integer

End Class


