Option Strict Off
Option Explicit On
Imports System.Runtime.InteropServices

Module Cx2Stat

    '-----------------------------------------------------------------------------------CX API Wrapper function
    Public Function CvSetCommand( _
            ByVal lPortNum As Integer, _
            ByVal Cmd As String, _
            ByVal dwCmdLen As Integer _
            ) As Integer

        Dim ByteArray As Byte()

        ByteArray = System.Text.Encoding.GetEncoding(65001).GetBytes(Cmd)

        Dim gchCmd As GCHandle = GCHandle.Alloc(ByteArray, GCHandleType.Pinned)
        Dim lpCmd As Integer = gchCmd.AddrOfPinnedObject().ToInt32()

        CvSetCommand = PrgEnv.CvSetCommand_(lPortNum, lpCmd, dwCmdLen)

        gchCmd.Free()

    End Function

    Public Function CvSetData( _
            ByVal lPortNum As Integer, _
            ByVal ByteArray() As Byte, _
            ByVal dwLen As Integer _
            ) As Integer

        Dim gchCmd As GCHandle = GCHandle.Alloc(ByteArray, GCHandleType.Pinned)
        Dim lpCmd As Integer = gchCmd.AddrOfPinnedObject().ToInt32()

        CvSetData = PrgEnv.CvSetCommand_(lPortNum, lpCmd, dwLen)

        gchCmd.Free()

    End Function


    Public Function CvGetCommand( _
                    ByVal lPortNum As Integer, _
                    ByVal Cmd As String, _
                    ByVal dwCmdLen As Integer, _
                    ByRef rb As String, _
                    ByVal dwRetBuffSize As Integer, _
                    ByRef dwRetLen As Integer _
                    ) As Integer

        Dim ByteArray As Byte()

        ByteArray = System.Text.Encoding.GetEncoding(65001).GetBytes(Cmd)

        Dim gchCmd As GCHandle = GCHandle.Alloc(ByteArray, GCHandleType.Pinned)
        Dim gchRetLen As GCHandle = GCHandle.Alloc(dwRetLen, GCHandleType.Pinned)
        Dim lpCmd As Integer = gchCmd.AddrOfPinnedObject().ToInt32()
        Dim lpdwRetLen As Integer = gchCmd.AddrOfPinnedObject().ToInt32()

        CvGetCommand = PrgEnv.CvGetCommand_(lPortNum, lpCmd, dwCmdLen, rb, dwRetBuffSize, lpdwRetLen)

        gchCmd.Free()
        gchRetLen.Free()

    End Function

    Public Function CvGetCommandEX( _
                ByVal lPortNum As Integer, _
                ByVal Cmd As String, _
                ByVal dwCmdLen As Integer, _
                ByRef rb As String, _
                ByVal dwRetBuffSize As Integer _
                ) As Integer

        Dim ByteArray As Byte()

        ByteArray = System.Text.Encoding.GetEncoding(65001).GetBytes(Cmd)

        Dim gchCmd As GCHandle = GCHandle.Alloc(ByteArray, GCHandleType.Pinned)
        Dim lpCmd As Integer = gchCmd.AddrOfPinnedObject().ToInt32()

        CvGetCommandEX = PrgEnv.CvGetCommandEX_(lPortNum, lpCmd, dwCmdLen, rb, dwRetBuffSize)

        gchCmd.Free()

    End Function

    Public Function SetCommand( _
                ByVal lPortNum As Integer, _
                ByVal Cmd As String, _
                ByVal dwCmdLen As Integer _
                ) As Integer
        SetCommand = CvSetCommand(lPortNum, Cmd, dwCmdLen)

    End Function

    Public Function GetCommand( _
                ByVal lPortNum As Integer, _
                ByVal Cmd As String, _
                ByVal dwCmdLen As Integer, _
                ByRef rb As String, _
                ByVal dwRetBuffSize As Integer, _
                ByRef dwRetLen As Integer _
                ) As Integer

        GetCommand = CvGetCommand(lPortNum, Cmd, dwCmdLen, rb, dwRetBuffSize, dwRetLen)

    End Function

    Public Function GetCommandEX( _
            ByVal lPortNum As Integer, _
            ByVal Cmd As String, _
            ByVal dwCmdLen As Integer, _
            ByRef rb As String, _
            ByVal dwRetBuffSize As Integer _
            ) As Integer

        GetCommandEX = CvGetCommandEX(lPortNum, Cmd, dwCmdLen, rb, dwRetBuffSize)

    End Function

    Public Function SetFirmwDataWrite( _
            ByVal lPortNum As Integer, _
            ByVal ByteArray() As Byte, _
            ByVal dwLen As Integer _
            ) As Integer

        Dim gchCmd As GCHandle = GCHandle.Alloc(ByteArray, GCHandleType.Pinned)
        Dim lpCmd As Integer = gchCmd.AddrOfPinnedObject().ToInt32()
        SetFirmwDataWrite = PrgEnv.SetFirmwDataWrite_(lPortNum, lpCmd, dwLen)

        gchCmd.Free()

    End Function

    Public Function CvSetFirmwDataWrite( _
            ByVal lPortNum As Integer, _
            ByVal ByteArray() As Byte, _
            ByVal dwLen As Integer _
            ) As Integer

        CvSetFirmwDataWrite = SetFirmwDataWrite(lPortNum, ByteArray, dwLen)

    End Function


    Public Function CvSetColorDataVersion( _
            ByVal lPortNum As Integer, _
            ByVal Cmd As String, _
            ByVal dwCmdLen As Integer _
            ) As Integer

        Dim ByteArray As Byte()

        ByteArray = System.Text.Encoding.GetEncoding(65001).GetBytes(Cmd)

        Dim gchCmd As GCHandle = GCHandle.Alloc(ByteArray, GCHandleType.Pinned)
        Dim lpCmd As Integer = gchCmd.AddrOfPinnedObject().ToInt32()

        CvSetColorDataVersion = PrgEnv.CvSetColorDataVersion_(lPortNum, lpCmd, dwCmdLen)

        gchCmd.Free()

    End Function

    Public Function SetColorDataVersion( _
            ByVal lPortNum As Integer, _
            ByVal Cmd As String, _
            ByVal dwCmdLen As Integer _
            ) As Integer

        SetColorDataVersion = CvSetColorDataVersion(lPortNum, Cmd, dwCmdLen)

    End Function

    Public Function CvSetColorDataWrite( _
            ByVal lPortNum As Integer, _
            ByVal ByteArray() As Byte, _
            ByVal dwLen As Integer _
            ) As Integer

        Dim gchCmd As GCHandle = GCHandle.Alloc(ByteArray, GCHandleType.Pinned)
        Dim lpCmd As Integer = gchCmd.AddrOfPinnedObject().ToInt32()

        CvSetColorDataWrite = PrgEnv.CvSetColorDataWrite_(lPortNum, lpCmd, dwLen)

        gchCmd.Free()

    End Function

    Public Function SetColorDataWrite( _
            ByVal lPortNum As Integer, _
            ByVal ByteArray() As Byte, _
            ByVal dwLen As Integer _
            ) As Integer

        SetColorDataWrite = CvSetColorDataWrite(lPortNum, ByteArray, dwLen)

    End Function

End Module
