Imports System.Runtime.InteropServices
'Imports System.ComponentModel

Public Module PrinterGlobal

	'*! ---------------------------------------
	'*	Declare the import functions.
	'*  ---------------------------------------
	<DllImport("kernel32.dll", EntryPoint:="lstrlenA", _
	   SetLastError:=True, CharSet:=CharSet.Unicode, _
	   ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
	Public Function lstrlen(ByVal lpString As IntPtr) As Integer
	End Function

	<DllImport("winspool.Drv", EntryPoint:="OpenPrinterW", _
	 SetLastError:=True, CharSet:=CharSet.Unicode, _
	 ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
	 Public Function OpenPrinter(ByVal src As String, ByRef hPrinter As IntPtr, ByVal pd As Integer) As Boolean
	End Function

	<DllImport("winspool.Drv", EntryPoint:="EnumJobsA", _
	   SetLastError:=True, CharSet:=CharSet.Unicode, _
	   ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
	Public Function EnumJobs(ByVal hPrinter As Integer, ByVal FirstJob As Integer, ByVal NoJobs As Integer, _
	 ByVal Level As Integer, ByRef pJob As IntPtr, ByVal cdBuf As Integer, ByRef pcbNeeded As Integer, ByRef pcReturned As Integer) As Integer
	End Function

	<DllImport("winspool.Drv", EntryPoint:="ClosePrinter", _
	   SetLastError:=True, CharSet:=CharSet.Unicode, _
	   ExactSpelling:=True, CallingConvention:=CallingConvention.StdCall)> _
	Public Function ClosePrinter(ByVal hPrinter As IntPtr) As Boolean
	End Function

	<DllImport("winspool.drv", SetLastError:=True)> _
	Public Function GetPrinter( _
	 ByVal hPrinter As IntPtr, ByVal dwLevel As Integer, _
	 ByVal pPrinter As IntPtr, ByVal cbBuf As Integer, _
	 ByRef pcbNeeded As Integer) As Boolean
	End Function

	<StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Auto)> _
	Public Structure PRINTER_INFO_5
		Public pPrinterName As IntPtr
		Public pPortName As IntPtr
		Public Attributes As Integer
		Public DeviceNotSelectedTimeout As Integer
		Public TransmissionRetryTimeout As Integer
	End Structure

	'*! ---------------------------------------
	'*	Declare the global variables.
	'*  ---------------------------------------
	Public sPrinterName As String		' Printer name
	Public sPortName As String			' USB port name
	Public sPortNo As Integer			' Port number



End Module
